#ifndef PLAYLISTPARSER_H
#define PLAYLISTPARSER_H

#include <QString>
#include <QUrl>

#include "playlistloop.h"

class PlaylistParser : public QObject
{
    Q_OBJECT

public:
    PlaylistParser() : QObject() {}
    static PlaylistParser *get(QUrl url);
    virtual PlaylistLoop *selectLoop() = 0;
    virtual void refresh() = 0;
};

class FlatPlaylistParser : public PlaylistParser
{
public:
    FlatPlaylistParser(QString &data);
    PlaylistLoop *selectLoop();
    void refresh();

private:
    PlaylistLoop *m_loop;
    QString m_data;
};

class XmlPlaylistParser : public PlaylistParser
{
public:
    XmlPlaylistParser(QString &data, QString baseUrl = QString());
    bool isValid() { return m_valid; }
    PlaylistLoop *selectLoop();
    void refresh();
    QString getName(){ return m_name;}

private:
    QString m_baseUrl;
    QList<PlaylistLoop *> m_loops;
    bool m_valid;
    QString m_name;
};

#endif
