#include "remote.h"

#include <QScriptEngine>


Remote::Remote(QObject *parent)
{
    qDebug()<<"Remote started";
    this->bind(QHostAddress::LocalHost,54545);
    connect(this,SIGNAL(readyRead()),this,SLOT(processMessage()));
}

void Remote::sendLoop(int id)
{
    QUdpSocket socket;
    socket.writeDatagram(QString("{'loopid': "+QString::number(id)+"}").toAscii(),QHostAddress::LocalHost,54546);
}

void Remote::processMessage()
{
    while (this->hasPendingDatagrams()) {
            QByteArray datagram;
            datagram.resize(this->pendingDatagramSize());
            QHostAddress sender;
            quint16 senderPort;

            this->readDatagram(datagram.data(), datagram.size(),
                                    &sender, &senderPort);
            QString message = QString(datagram);
            qDebug()<<message;
            QScriptEngine engine;
            QScriptValue v = engine.evaluate("("+message+")");
            switch(v.property("action").toVariant().toInt()){
            case PAUSE:
                emit pause();
                break;
            case GOTO:
                emit goTo(v.property("data").toInteger());
                break;
            case NEXT:
                emit next();
                break;
            case RESTART:
                emit restart();
                break;
            case SCREENSHOT:
                emit screenshot();
                break;
            case TEXT:
                emit text(v.property("data").property("text").toString(), v.property("data").property("duration").toVariant().toInt());
                emit screenshot();
            }
    }
}
