#ifndef REMOTE_H
#define REMOTE_H

#include <QTcpServer>
#include <QTcpSocket>
#include <QUdpSocket>

class Remote : public QUdpSocket
{
    Q_OBJECT
private:
    enum ACTION{PAUSE, NEXT, GOTO, SCREENSHOT, RESTART, TEXT};
public:
    explicit Remote(QObject *parent = 0);
    void sendLoop(int id);

signals:
    void pause();
    void next();
    void goTo(int);
    void screenshot();
    void restart();
    void text(const QString &, int);
public slots:
    void processMessage();
};

#endif // REMOTE_H
