#include <QTime>
#include <QTimer>

#ifndef RUNNABLE_H
#define RUNNABLE_H

class Runnable
{
public:
    virtual void run() = 0;
    virtual void stop() = 0;
    virtual void pause()
    {
        if(m_timer.isActive()){
            m_remainingTime = m_time - m_elapsed.elapsed();
            m_timer.stop();
        }
        else{
            m_elapsed.restart();
            m_timer.start();
        }
    }
protected:
    QTimer m_timer;
    QTime m_elapsed;
    int m_time;
    int m_remainingTime;
};

//Q_DECLARE_INTERFACE(Runnable, "com.linutop.Runnable")

#endif
