#!/usr/bin/python
# -*- coding: latin-1 -*-

from bottle import route, run, template, static_file, request
from settings import Settings
import httplib, urllib, json, re, os, requests, socket, psutil, sys, time
from urlparse import urlparse

settings = Settings()
loopid = 0
UDP_IP = '127.0.0.1'
UDP_PORT = 54545
BUFFER_SIZE = 1024
PAUSE = 0
NEXT = 1
GOTO = 2
SCREENSHOT = 3
RESTART = 4
TEXT = 5
clientRunning = False
socketclient = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
execpath = "linutop-webkiosk"
print os.path.dirname(os.path.realpath(sys.argv[0]))
os.chdir(os.path.dirname(os.path.realpath(sys.argv[0])))
dev = len(sys.argv)>1 and sys.argv[1]=='dev'
if dev:
    execpath = "~/webkiosk-ng-build/bin/linutop-webkiosk"
    

def makeServer():
    socketclient.setsockopt(socket.SOL_SOCKET,socket.SO_REUSEADDR, 1)
    socketserver = socketclient
    socketserver.bind((UDP_IP,UDP_PORT+1))
    while True:
        message = socketserver.recvfrom()

def checkProgram():
    all_processes = list(psutil.process_iter())
    for proc in all_processes:
        if proc.name() == "linutop-webkiosk":
            return True
    return False

@route('/control/pause', method="POST")
def play():
    socketclient.sendto(json.dumps({"action": PAUSE}),(UDP_IP,UDP_PORT))
@route('/remote/goto', method="POST")
def goto():
    socketclient.sendto(json.dumps({"action": GOTO, "data": request.forms['index']}),(UDP_IP,UDP_PORT))
@route('/control/next', method="POST")
def next():
    socketclient.sendto(json.dumps({"action": NEXT}),(UDP_IP,UDP_PORT))
@route('/remote/screenShot', method="POST")
def screenShot():
    socketclient.sendto(json.dumps({"action": SCREENSHOT}),(UDP_IP,UDP_PORT))
@route('/remote/launch',method="POST")
def launch():
    if not checkProgram():
        os.system('sudo -u linutop '+ execpath +' &')
@route('/remote/start', method='POST')
def start():
    (url,a,b) = settings.getServer()
    settings.setServer(url+'/webapp/p/'+request.forms['screen'])
    launch()
    socketclient.sendto(json.dumps({"action": RESTART}),(UDP_IP,UDP_PORT))

@route('/res/screen')
def screen():
    time.sleep(1)
    return static_file("/tmp/screen.png",root='/');
@route('/remote/text', method="POST")
def text():
    for form in request.forms:
        print form
        pass
    socketclient.sendto(json.dumps({"action": TEXT, "data": {"text":request.forms.get('text'), "duration": 30}}), (UDP_IP,UDP_PORT))
@route('/static/<filepath:path>')
def server_static(filepath):
    return static_file(filepath, root='./web')
@route('/')
def home():
    return static_file('index.html',root='./web')
@route("/info")
def info():
    (url, invoice, email) = settings.getServer()
    headers = {"Content-type": "application/x-www-form-urlencoded; charset=UTF-8","Accept": "application/json"}
    response = requests.post(url+"/webapp/api/user/"+str(invoice),data={"model":json.dumps({"invoice":str(invoice), "email":email})},headers=headers)
    if response.status_code != requests.codes.ok:
        invoice = "public"
    return json.dumps({"url": url, "invoice": invoice})
@route('/remote')
def remote():
    return static_file('remote.html',root='./web')
@route('/remote/channels')
def remote():
    (url, login, password) = settings.getServer()
    headers = {"Content-type": "application/x-www-form-urlencoded; charset=UTF-8","Accept": "application/json"}
    response = requests.post(url+"/webapp/api/user/"+str(login),data={"model":json.dumps({"invoice":str(login), "email":password})},headers=headers)
    if response.status_code != requests.codes.ok:
        response = requests.get(url+"/webapp/db/channels",headers=headers)
    return json.dumps(response.json())
@route('/remote/playlist')
def playlist():
    if(settings.getRemote()=='true'):
        file = open('/home/linutop/.linutop-kiosk/playlist')
        reply =  json.dumps({"loopid": loopid, "xml":file.read()})
        file.close()
        return reply

run(host='', port=8080, debug=dev)
